Bug 46279 - Show restart message after extension installation or update menu automatically
Summary: Show restart message after extension installation or update menu automatically
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Extensions (show other bugs)
Version:
(earliest affected)
3.5.0 release
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:5.3.0
Keywords: difficultyInteresting, easyHack, skillCpp
Depends on:
Blocks:
 
Reported: 2012-02-19 03:42 UTC by Daniel Naber
Modified: 2018-04-19 11:44 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Daniel Naber 2012-02-19 03:42:51 UTC
Some extensions (like LanguageTool) require LO to be restartet, they won't work otherwise. The problem is that the user doesn't get any message about this. There should be a dialog asking the user to restart LO after extension installation.
Comment 1 sasha.libreoffice 2012-05-21 08:37:12 UTC
Thanks for bugreport
Please, tell about this to authors these extensions. IMHO they will solve this problem more quickly.
Comment 2 Daniel Naber 2012-07-02 11:52:57 UTC
I *am* the author of the extension :-) I think the need to restart LO is a limitation of LO, so it should handle the usability issues that this limitation causes.
Comment 3 sasha.libreoffice 2012-07-06 04:01:17 UTC
Thanks for additional information.
Please, provide link to this extension or attach it. This needed for testing purposes.
Comment 4 Daniel Naber 2012-07-06 04:30:01 UTC
The extension can be downloaded from http://www.languagetool.org/download/LanguageTool-stable.oxt?1.8
Comment 5 sasha.libreoffice 2012-07-06 07:07:29 UTC
Thanks for link
in 3.6.b1 on Fedora 64 bit reproduced that no message about restarting appears
But it works without restarting correctly.
May be needing for restarting is Windows-only problem?
Comment 6 Daniel Naber 2012-07-06 07:11:25 UTC
Thanks for testing - but the "LanguageTool" entry in the Tools menu (or whatever it's called in the English version) did not appear without restart, did it?
Comment 7 sasha.libreoffice 2012-07-06 08:00:55 UTC
When I have opened Writer and added this extension, "LanguageTool" entry not appeared. But after File->Open and opening any document this items appears.
May be we should ask developers for adding automatic updating of menu item? For users no needed to open document.

IMHO almost all users will try to open some documents after installing this extension for see how it works. So, I see no problem. At least on Linux.

On Windows not tested. There situation may be much worse.
Comment 8 Daniel Naber 2012-07-06 08:24:10 UTC
I disagree that users will open a new document without a message telling them to do so. They could as well want to use the extension on a document already opened. So I still consider this a usability problem.
Comment 9 Urmas 2013-01-23 14:15:20 UTC
All dictionaries require restart to work. The application should ask for restart and re-open current documents automatically.
Comment 10 Thorsten Behrens (CIB) 2014-07-29 23:26:37 UTC
That does not sound impossible to do. Poking around a bit in desktop/, I find existing code that restarts the office, e.g. when a weirdo jre selection would make that necessary. Random code pointers:

grep for: OfficeRestartManager

desktop/source/app/app.cxx:68:#include <com/sun/star/task/OfficeRestartManager.hpp>
desktop/source/app/app.cxx:1418:    Reference< XRestartManager > xRestartManager( OfficeRestartManager::get(xContext) );
desktop/source/app/app.cxx:1727:        OfficeRestartManager::get(comphelper::getProcessComponentContext())->
desktop/source/app/check_ext_deps.cxx:46:#include <com/sun/star/task/OfficeRestartManager.hpp>
desktop/source/app/check_ext_deps.cxx:423:        task::OfficeRestartManager::get(context)->requestRestart(
svtools/source/dialogs/restartdialog.cxx:14:#include <com/sun/star/task/OfficeRestartManager.hpp>
svtools/source/dialogs/restartdialog.cxx:77:        css::task::OfficeRestartManager::get(context)->requestRestart(
desktop/source/deployment/misc/dp_misc.cxx:41:#include <com/sun/star/task/OfficeRestartManager.hpp>
desktop/source/deployment/misc/dp_misc.cxx:565:        Reference<task::XRestartManager> restarter(task::OfficeRestartManager::get(comphelper::getProcessComponentContext()));

etc. This is even at the api, so extensions can use it directly:

offapi/com/sun/star/task/OfficeRestartManager.idl:33:singleton OfficeRestartManager : XRestartManager;
Comment 11 Robinson Tryon (qubit) 2015-12-14 05:03:43 UTC Comment hidden (obsolete)
Comment 12 iremsendur 2016-01-28 14:46:09 UTC
 Hi, I'm working on this bug. And I'm trying to do live menu updating. I couldn't find newly installed extension's configuration file. Which directory are they being hold, is that extensions/source/update/check/org/openoffice/Office/Addons.xcu ? And should I check the configuration data shouldn't I ?
Comment 13 Robinson Tryon (qubit) 2016-02-18 14:51:46 UTC Comment hidden (obsolete)
Comment 14 Commit Notification 2016-06-23 06:45:39 UTC
irem committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2c1056d679187a702bad3a2ba5dcb6b068e1aa5e

tdf#46279 Show restart message after extension installation

It will be available in 5.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 15 jani 2016-06-24 06:44:18 UTC
Seems solved
Comment 16 Cor Nouws 2016-07-12 11:37:30 UTC
(In reply to Commit Notification from comment #14)

> Affected users are encouraged to test the fix and report feedback.

Hi,

Most extensions that I use do not require restart.
But now it is presented as if is is needed.
IMO this is not a desired situation.

To solve this, possibly an extension of the description.xml package could help?
Comment 17 Cor Nouws 2016-09-28 15:59:57 UTC
ping - is my complaint moot ? :)
Comment 18 Cor Nouws 2016-10-07 08:52:30 UTC
Maybe it's best to extend the description.xml in the package to have a <askrestart> node and use that for choosing the needed action in the UI.
Comment 19 Katarina Behrens (CIB) 2016-10-07 14:13:20 UTC
(In reply to Cor Nouws from comment #18)
> Maybe it's best to extend the description.xml in the package to have a
> <askrestart> node and use that for choosing the needed action in the UI.

Nah, it makes a lot of sense. The only concern would perhaps be backwards compatibility and good choice of default value
Comment 20 Cor Nouws 2016-10-07 14:38:26 UTC
(In reply to Katarina Behrens (CIB) from comment #19)
> (In reply to Cor Nouws from comment #18)
> > Maybe it's best to extend the description.xml in the package to have a
> > <askrestart> node and use that for choosing the needed action in the UI.
> 
> Nah, it makes a lot of sense. The only concern would perhaps be backwards
> compatibility and good choice of default value

Thanks. Safe is that only extensions that need a restart will need to use that property. No property, no restart.
Comment 21 Yousuf Philips (jay) (retired) 2016-10-07 18:20:02 UTC
(In reply to Cor Nouws from comment #18)
> Maybe it's best to extend the description.xml in the package to have a
> <askrestart> node and use that for choosing the needed action in the UI.

+1
Comment 22 Heiko Tietze 2016-10-14 17:10:14 UTC
As discussed in the UX meeting Oct/14 the recommendation is to revert the patch; and in general to add the restart option to the extension specification.
Comment 23 jani 2016-10-14 18:02:43 UTC
Hi Irem

I am sorry for the fuzz on your excellent work. You did what the ticket asked you to do, you even asked questions about implementation details, so I consider your work as valuable !!

Sometimes when people see how a patch work, they realise the implementation (again not your work) detail should have been different, this is unfortunate but happens in real life...in this case we normally do not revert the patch, but open a new ticket, that can extend/change/enhance the work you have done.

I hope you will continue have fun with LO, and please contact me, if I can do anything to help.
Comment 24 Cor Nouws 2016-10-14 18:41:06 UTC
Hi,

(In reply to jan iversen from comment #23)

> I am sorry for the fuzz on your excellent work. You did what the ticket
> asked you to do, you even asked questions about implementation details, so I
> consider your work as valuable !!

Let me support you in that, Jan!

> Sometimes when people see how a patch work, they realise the implementation
> (again not your work) detail should have been different, this is unfortunate
> but happens in real life...in this case we normally do not revert the patch,
> but open a new ticket, that can extend/change/enhance the work you have done.

Of course that is fine too. Maybe it is interesting for Irem or someone else to expand the initial work a bit?
Comment 25 Jan Holesovsky 2016-10-17 10:38:35 UTC
Please let's stop the discussion here.  Irem who successfully finished this EasyHack did a great work here - he's done what he was asked for.

If there are further improvements to the solution needed (like a flag to say that the extension needs a restart - which is a good idea I believe), please let's discuss it in a new bug.  Thank you!